Index: sasmodels/conversion_table.py
===================================================================
--- sasmodels/conversion_table.py	(revision 5f1acda0bb84d51fb552a3fe3066b6f523837731)
+++ sasmodels/conversion_table.py	(revision bb584b3946fe8b5a6ab2d1a751f4b80ad63cf1b8)
@@ -5,9 +5,28 @@
 names for each parameter in sasmodels.  This is used by :mod:`convert` to
 determine the equivalent parameter set when comparing a sasmodels model to
-the models defined in SasView 3.1.
+the models defined in previous versions of SasView and sasmodels. This is now
+versioned based on the version number of SasView.
+
+When any sasmodels parameter or model name is changed, this must be modified to
+account for that.
+
+Usage:
+<old_Sasview_version> : {
+    <new_model_name> : [
+        <old_model_name> ,
+        {
+            <new_param_name_1> : <old_param_name_1>,
+            ...
+            <new_param_name_n> : <old_param_name_n>
+        }
+    ]
+}
+
+Any future parameter and model name changes can and should be given in this
+table for future compatibility.
 """
 
-
 CONVERSION_TABLE = {
+    (3,1,2) : {
     "adsorbed_layer": [
         "Core2ndMomentModel",
@@ -143,16 +162,16 @@
         }
     ],
-    "core_shell_ellipsoid": [
+    "core_shell_ellipsoid:1": [
         "CoreShellEllipsoidModel",
         {
+            "sld_core": "sld_core",
+            "sld_shell": "sld_shell",
+            "sld_solvent": "sld_solvent",
+            "radius_equat_core": "equat_core",
+            "x_core": "polar_core",
+            "thick_shell": "equat_shell",
+            "x_polar_shell": "polar_shell",
+            "theta": "axis_theta",
             "phi": "axis_phi",
-            "sld_core": "sld_core",
-            "polar_shell": "polar_shell",
-            "sld_solvent": "sld_solvent",
-            "equat_shell": "equat_shell",
-            "equat_core": "equat_core",
-            "theta": "axis_theta",
-            "polar_core": "polar_core",
-            "sld_shell": "sld_shell"
         }
     ],
@@ -160,12 +179,13 @@
         "CoreShellEllipsoidXTModel",
         {
-            "phi": "axis_phi",
             "sld_core": "sld_core",
+            "sld_shell": "sld_shell",
+            "sld_solvent": "sld_solvent",
+            "radius_equat_core": "equat_core",
+            "thick_shell": "T_shell",
             "x_core": "X_core",
-            "sld_solvent": "sld_solvent",
-            "thick_shell": "T_shell",
             "x_polar_shell": "XpolarShell",
             "theta": "axis_theta",
-            "sld_shell": "sld_shell"
+            "phi": "axis_phi",
         }
     ],
@@ -173,18 +193,18 @@
         "CSParallelepipedModel",
         {
+            "sld_core": "sld_pcore",
+            "sld_a": "sld_rimA",
+            "sld_b": "sld_rimB",
+            "sld_c": "sld_rimC",
+            "sld_solvent": "sld_solv",
+            "length_a": "shortA",
+            "length_b": "midB",
+            "length_c": "longC",
+            "thick_rim_a": "rimA",
+            "thick_rim_c": "rimC",
+            "thick_rim_b": "rimB",
+            "theta": "parallel_theta",
             "phi": "parallel_phi",
             "psi": "parallel_psi",
-            "sld_core": "sld_pcore",
-            "sld_c": "sld_rimC",
-            "sld_b": "sld_rimB",
-            "sld_solvent": "sld_solv",
-            "length_a": "shortA",
-            "sld_a": "sld_rimA",
-            "length_b": "midB",
-            "thick_rimc": "rimC",
-            "theta": "parallel_theta",
-            "thick_rim_a": "rimA",
-            "length_c": "longC",
-            "thick_rim_b": "rimB"
         }
     ],
@@ -210,5 +230,5 @@
     ],
     "correlation_length": [
-        "CorrLengthModel",
+        "CorrLength",
         {
             "porod_scale": "scale_p",
@@ -217,5 +237,6 @@
             "lorentz_exp": "exponent_l",
             "cor_length": "length_l"
-        }
+        },
+        "CorrLengthModel"
     ],
     "cylinder": [
@@ -240,5 +261,5 @@
         "DABModel",
         {
-            "length": "length"
+            "cor_length": "length"
         }
     ],
@@ -257,10 +278,11 @@
         "EllipticalCylinderModel",
         {
+            "axis_ratio": "r_ratio",
+            "radius_minor": "r_minor",
+            "sld": "sldCyl",
+            "sld_solvent": "sldSolv",
+            "theta": "cyl_theta",
             "phi": "cyl_phi",
             "psi": "cyl_psi",
-            "theta": "cyl_theta",
-            "sld": "sldCyl",
-            "axis_ratio": "r_ratio",
-            "sld_solvent": "sldSolv"
         }
     ],
@@ -297,10 +319,16 @@
     ],
     "fractal_core_shell": [
-        "FractalCoreShellModel",
-        {
+        "FractalCoreShell",
+        {
+            "sld_core": "core_sld",
             "sld_shell": "shell_sld",
             "sld_solvent": "solvent_sld",
-            "sld_core": "core_sld"
-        }
+            "radius": "radius",
+            "thickness": "thickness",
+            "fractal_dim": "frac_dim",
+            "cor_length": "cor_length",
+            "volfraction": "volfraction",
+        },
+        "FractalCoreShellModel"
     ],
     "fuzzy_sphere": [
@@ -314,5 +342,5 @@
     ],
     "gauss_lorentz_gel": [
-        "GaussLorentzGelModel",
+        "GaussLorentzGel",
         {
             "gauss_scale": "scale_g",
@@ -321,11 +349,14 @@
             "background": "background",
             "lorentz_scale": "scale_l"
-        }
+        },
+        "GaussLorentzGelModel"
     ],
     "gaussian_peak": [
+        "Peak Gauss Model",
+        {
+            "peak_pos": "q0",
+            "sigma": "B",
+        },
         "PeakGaussModel",
-        {
-            "sigma": "B"
-        }
     ],
     "gel_fit": [
@@ -334,31 +365,32 @@
             "rg": "radius",
             "lorentz_scale": "lScale",
+            "guinier_scale": "gScale",
             "fractal_dim": "FractalExp",
             "cor_length": "zeta",
-            "guinier_scale": "gScale"
         }
     ],
     "guinier": [
+        "Guinier",
+        {
+            "rg": "rg"
+        },
         "GuinierModel",
-        {
-            "rg": "rg"
-        }
     ],
     "guinier_porod": [
-        "GuinierPorodModel",
+        "GuinierPorod",
         {
             "s": "dim",
             "rg": "rg",
-            "m": "m",
+            "porod_exp": "m",
             "scale": "scale",
             "background": "background"
-        }
+        },
+        "GuinierPorodModel",
     ],
     "hardsphere": [
         "HardsphereStructure",
         {
-            "radius_effective_pd": "effect_radius_pd",
+            "scale": "scale_factor",
             "radius_effective": "effect_radius",
-            "radius_effective_pd_n": "effect_radius_pd_n"
         }
     ],
@@ -366,8 +398,11 @@
         "HayterMSAStructure",
         {
-            "salt_concentration": "saltconc",
-            "radius_effective_pd": "effect_radius_pd",
+            "scale": "scale_factor",
             "radius_effective": "effect_radius",
-            "radius_effective_pd_n": "effect_radius_pd_n"
+            "volfraction": "volfraction",
+            "charge": "charge",
+            "temperature": "temperature",
+            "concentration_salt": "saltconc",
+            "dielectconst": "dielectconst",
         }
     ],
@@ -375,13 +410,11 @@
         "HollowCylinderModel",
         {
+            "sld": "sldCyl",
+            "sld_solvent": "sldSolv",
+            "radius": "core_radius",
+            "thickness": "radius",
+            "length": "length",
+            "theta": "axis_theta",
             "phi": "axis_phi",
-            "scale": "scale",
-            "radius_core": "core_radius",
-            "sld_solvent": "sldSolv",
-            "length": "length",
-            "radius": "radius",
-            "background": "background",
-            "sld": "sldCyl",
-            "theta": "axis_theta"
         }
     ],
@@ -389,10 +422,10 @@
         "RectangularHollowPrismModel",
         {
+            "sld": "sldPipe",
+            "sld_solvent": "sldSolv",
+            "length_a": "short_side",
             "b2a_ratio": "b2a_ratio",
-            "length_a": "short_side",
-            "sld": "sldPipe",
-            "length_c": "c2a_ratio",
-            "sld_solvent": "sldSolv",
-            "thickness": "thickness"
+            "c2a_ratio": "c2a_ratio",
+            "thickness": "thickness",
         }
     ],
@@ -401,8 +434,8 @@
         {
             "sld": "sldPipe",
+            "sld_solvent": "sldSolv",
+            "length_a": "short_side",
             "b2a_ratio": "b2a_ratio",
-            "length_a": "short_side",
-            "length_c": "c2a_ratio",
-            "sld_solvent": "sldSolv"
+            "c2a_ratio": "c2a_ratio",
         }
     ],
@@ -428,11 +461,12 @@
         "LamellarPSHGModel",
         {
+            "sld": "sld_tail",
+            "sld_head": "sld_head",
+            "sld_solvent": "sld_solvent",
+            "length_tail": "deltaT",
+            "length_head": "deltaH",
+            "d_spacing": "spacing",
             "Caille_parameter": "caille",
             "Nlayers": "n_plates",
-            "sld_head": "sld_head",
-            "length_tail": "deltaT",
-            "length_head": "deltaH",
-            "sld": "sld_tail",
-            "sld_solvent": "sld_solvent"
         }
     ],
@@ -441,8 +475,9 @@
         {
             "sld": "sld_bi",
+            "sld_solvent": "sld_sol",
+            "thickness": "delta",
+            "d_spacing": "spacing",
             "Caille_parameter": "caille",
-            "Nlayers": "N_plates",
-            "sld_solvent": "sld_sol",
-            "thickness": "delta"
+            "Nlayers": "n_plates",
         }
     ],
@@ -451,6 +486,9 @@
         {
             "sld": "sld_layer",
+            "sld_solvent": "sld_solvent",
+            "thickness": "thickness",
+            "d_spacing": "spacing",
             "sigma_d": "pd_spacing",
-            "sld_solvent": "sld_solvent"
+            "Nlayers": "Nlayers",
         }
     ],
@@ -473,8 +511,9 @@
     ],
     "lorentz": [
+        "Lorentz",
+        {
+            "cor_length": "length"
+        },
         "LorentzModel",
-        {
-            "cor_length": "length"
-        }
     ],
     "mass_fractal": [
@@ -497,10 +536,11 @@
     ],
     "mono_gauss_coil": [
+        "Debye",
+        {
+            "rg": "rg",
+            "i_zero": "scale",
+            "background": "background",
+        },
         "DebyeModel",
-        {
-            "rg": "rg",
-            "scale": "scale",
-            "background": "background"
-        }
     ],
     "multilayer_vesicle": [
@@ -551,9 +591,10 @@
     ],
     "peak_lorentz": [
-        "PeakLorentzModel",
+        "Peak Lorentz Model",
         {
             "peak_pos": "q0",
             "peak_hwhm": "B"
-        }
+        },
+        "PeakLorentzModel",
     ],
     "pearl_necklace": [
@@ -576,32 +617,39 @@
             "rg": "rg",
             "polydispersity": "poly_m",
+            "i_zero": "scale",
+            "background": "background",
+        }
+    ],
+    "polymer_excl_volume": [
+        "PolymerExclVolume",
+        {
+            "rg": "rg",
+            "scale": "scale",
+            "background": "background",
+            "porod_exp": "m"
+        }
+    ],
+    "polymer_micelle": [
+        "MicelleSphCoreModel",
+        {
+            "sld_corona": "rho_corona",
+            "sld_solvent": "rho_solv",
+            "sld_core": "rho_core",
+            "ndensity": "ndensity",
+            "v_core": "v_core",
+            "v_corona": "v_corona",
+            "radius_core": "radius_core",
+            "rg": "radius_gyr",
+            "d_penetration": "d_penetration",
+            "n_aggreg": "n_aggreg",
+        }
+    ],
+    "porod": [
+        "PorodModel",
+        {
             "scale": "scale",
             "background": "background"
         }
     ],
-    "polymer_excl_volume": [
-        "PolymerExclVolume",
-        {
-            "rg": "rg",
-            "scale": "scale",
-            "background": "background",
-            "porod_exp": "m"
-        }
-    ],
-    "polymer_micelle": [
-        "MicelleSphCoreModel",
-        {
-            "sld_corona": "rho_corona",
-            "sld_solvent": "rho_solv",
-            "sld_core": "rho_core"
-        }
-    ],
-    "porod": [
-        "PorodModel",
-        {
-            "scale": "scale",
-            "background": "background"
-        }
-    ],
     "power_law": [
         "PowerLawAbsModel",
@@ -616,5 +664,5 @@
         {
             "scale": "scale",
-            "solvent_sld": "sld_solvent",
+            "sld_solvent": "sld_solvent",
             "thickness": "thickness",
             "beta": "beta",
@@ -643,7 +691,7 @@
         {
             "sld": "sldPipe",
+            "length_a": "short_side",
             "b2a_ratio": "b2a_ratio",
-            "length_a": "short_side",
-            "length_c": "c2a_ratio",
+            "c2a_ratio": "c2a_ratio",
             "sld_solvent": "sldSolv"
         }
@@ -716,7 +764,8 @@
         "SquareWellStructure",
         {
-            "radius_effective_pd": "effect_radius_pd",
+            "scale": "scale_factor",
             "radius_effective": "effect_radius",
-            "radius_effective_pd_n": "effect_radius_pd_n"
+            "wellwidth": "wellwidth",
+            "welldepth": "welldepth",
         }
     ],
@@ -729,5 +778,7 @@
             "theta": "axis_theta",
             "sld_solvent": "solvent_sld",
-            "n_stacking": "n_stacking"
+            "n_stacking": "n_stacking",
+            "thick_layer": "layer_thick",
+            "thick_core": "core_thick",
         }
     ],
@@ -742,7 +793,6 @@
         "StickyHSStructure",
         {
-            "radius_effective_pd": "effect_radius_pd",
+            "scale": "scale_factor",
             "radius_effective": "effect_radius",
-            "radius_effective_pd_n": "effect_radius_pd_n"
         }
     ],
@@ -758,5 +808,10 @@
         "TeubnerStreyModel",
         {
-            "a2": "scale"
+            # Note: parameters are completely rewritten in convert.py
+            "volfraction_a": "volfraction_a",
+            "sld_a": "sld_a",
+            "sld_b": "sld_b",
+            "d": "d",
+            "xi": "xi",
         }
     ],
@@ -775,5 +830,5 @@
     ],
     "two_lorentzian": [
-        "TwoLorentzianModel",
+        "TwoLorentzian",
         {
             "lorentz_scale_1": "scale_1",
@@ -784,8 +839,9 @@
             "lorentz_length_1": "length_1",
             "background": "background"
-        }
+        },
+        "TwoLorentzianModel",
     ],
     "two_power_law": [
-        "TwoPowerLawModel",
+        "TwoPowerLaw",
         {
             "coefficent_1": "coef_A",
@@ -794,10 +850,20 @@
             "background": "background",
             "crossover": "qc"
-        }
+        },
+        "TwoPowerLawModel",
     ],
     "unified_power_Rg": [
+        "UnifiedPowerRg",
+        dict(((field_new+str(index), field_old+str(index))
+              for field_new, field_old in [("rg", "Rg"),
+                                           ("power", "power"),
+                                           ("G", "G"),
+                                           ("B", "B"),]
+              for index in range(11)),
+             **{
+                   "background": "background",
+                   "scale": "scale",
+               }),
         "UnifiedPowerRgModel",
-        {
-        }
     ],
     "vesicle": [
@@ -808,3 +874,4 @@
         }
     ]
+    }
 }
